<?php

/**
 * This is the model class for table "{{hoteles_videos}}".
 *
 * The followings are the available columns in table '{{hoteles_videos}}':
 * @property integer $id_video
 * @property integer $id_hotel
 * @property string $descripcion
 * @property string $video
 * @property string $log
 * @property string $tipo_video
 * @property integer $estatus
 */
class HotelesVideos extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return HotelesVideos the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{hoteles_videos}}';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('id_hotel, descripcion, video, log, tipo_video', 'required'),
			array('id_hotel, estatus', 'numerical', 'integerOnly'=>true),
			array('descripcion, tipo_video', 'length', 'max'=>250),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('id_video, id_hotel, descripcion, video, log, tipo_video, estatus', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id_video' => 'Id Video',
			'id_hotel' => 'Id Hotel',
			'descripcion' => 'Descripcion',
			'video' => 'Video',
			'log' => 'Log',
			'tipo_video' => 'Tipo Video',
			'estatus' => 'Estatus',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id_video',$this->id_video);
		$criteria->compare('id_hotel',$this->id_hotel);
		$criteria->compare('descripcion',$this->descripcion,true);
		$criteria->compare('video',$this->video,true);
		$criteria->compare('log',$this->log,true);
		$criteria->compare('tipo_video',$this->tipo_video,true);
		$criteria->compare('estatus',$this->estatus);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
}