<div class="modal fade" id="modalCancelarCupon" tabindex="-1" role="dialog" aria-labelledby="modalCancelarCuponLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title" id="modalCancelarCuponLabel">Cancelar Cupón</h4>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <form name="cancelar-cupon" method="post" id="cancelar-cupon" action="<?php echo Yii::app()->createUrl('reservacion/cancelar', array('id'=>$model->id_reservacion)); ?>">
          <div class="modal-body">
            <?php if(!empty($penalizacion)){ ?>
              <div class="alert alert-danger">Esta reservación tiene una penalización de <strong><?=$penalizacion['noches'] < 100 ? $penalizacion['noches'].' noche(s)':'Toda la Estancia'?></strong> para cancelar ahora. 
                Se debe cubrir el saldo correspondiente de <strong>$ <?=number_format($penalizacion['importe'],2).' MXN'?></strong> antes de cancelarlo.<br />
                <?php if($penalizacion['importe'] > $penalizacion['totalPagos']){ ?>
                  <button type="button" class="btn btn-danger m-t-sm" onclick="$('#form_cancelar').show()">Cancelar de Todas Formas</button>
                <?php } ?>
              </div>
            <?php } ?>
            <div id="form_cancelar" <?=(!empty($penalizacion) && $penalizacion['importe'] > $penalizacion['totalPagos']) == true ? 'style="display:none"':''?>>
              <?php if(!empty($penalizacion)){ ?>
                <input type="hidden" name="penalizacion" value="<?=$penalizacion['importe']?>" required="required" />
                <label class="md-check m-b">
                  <input type="checkbox" name="penalizar" <?=$penalizacion['importe'] > $penalizacion['totalPagos'] ? 'disabled':''?> />
                  <i class="red"></i>Aplicar Penalización
                </label>
              <?php } ?>
              <div class="form-group">
                <label for="motivo">Motivo: </label>
                <textarea name="motivo" id="motivo" class="form-control" autocomplete="off" required="required"/><?=$model->motivo?></textarea>
              </div>
              <?php if(!empty($this->palaceResorts[$model->idHotel->codigo])){ ?>
                <div class="form-group">
                  <label for="reason">Motivo (Para WebService): </label>
                  <textarea name="reason" id="reason" class="form-control" autocomplete="off" required="required"/><?=$model->motivo?></textarea>
                </div>
              <?php } ?>
              <div class="form-group">
                <label for="clave_confirmacion">Clave de confirmación: </label>
                <input type="password" name="clave_confirmacion" id="clave_confirmacion" class="form-control" autocomplete="off" required="required" />
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <button type="submit" class="btn btn-sm btn-danger" id="btn_cancelar" onclick="if(!confirm('¿Seguro que desea cancelar la reserva?')) return false;">Autorización Inmediata</button>
            <button type="submit" class="btn btn-sm btn-warning" id="btn_autorizar">Autorización Remota</button>
            <button type="button" class="btn btn-sm btn-default" data-dismiss="modal">Cerrar</button>
          </div>
        </form>
      </div>

    </div>
  </div>
</div>


<!-- modalcomision -->
<div id="modalcomision" class="modal modal-flex fade in" aria-labelledby="flexModalLabel" aria-hidden="true" >
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h4>Modificar Comisión <label id="lbl_cuponc" ></label></h4>
        <input type="hidden" id="comisionreserva" value="<?php echo $model->comision; ?>"  />
      </div>
      <div id="cuerpomodalc" class="modal-body">
       <?php $form=$this->beginWidget('bootstrap.widgets.TbActiveForm',array(
        'id'=>'comision-form',
        'enableAjaxValidation'=>false,
        'method'=>'post',
        'type'=>'horizontal',
        'htmlOptions'=>array(
          'enctype'=>'multipart/form-data',
        )
      )); ?>
      <fieldset>
        <input type="hidden" name="cuponc" id="cuponc" />
        <?php echo $form->errorSummary($modelComision,'Error!!!', null,array('class'=>'alert alert-error span12')); ?>
        <div class="alert alert-danger alert-dismissable" id="msg_errorc" style="display:none;">
          <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
          <div id="comision_error" ></div>
        </div>
        <div class="form-group">
          <div class="row">

            <label for="comision" class="col-sm-4 control-label">Comisión</label>
            <div class="controls col-sm-8">
              <input type="text" class="form-control text-right" id="comision" name="comision" value="" maxlength="10" autocomplete="off">
            </div>
          </div>
        </div>
        <div class="form-group">
          <div class="row">

            <label for="comision" class="col-sm-4 control-label">Clave de Confirmación</label>
            <div class="controls col-sm-8">
              <input type="password" class="form-control" id="clave" name="clave" autocomplete="off">
            </div>
          </div>
        </div>
      </fieldset>
      <?php $this->endWidget(); ?>
    </div>
    <div id="modalmensajec" class="modal-body">
    </div>
    <div class="modal-footer">
      <?php
      echo CHtml::ajaxLink(
        "Cambiar",
        array('pagos/cambiarcomision'),
        array(
         'type' => 'POST',
         'data'=>'js:$("#comision-form").serialize()',
         'beforeSend'=>'function(){
          if($("#comision").val() == "")
          {
            $("#comision_error").html("El valor de la comisión no puede ser vacío!")
            $("#msg_errorc").show();
            return false
          }
          if($("#clave").val() == "")
          {
            $("#comision_error").html("Debe introducir una clave de confirmación válida!")
            $("#msg_errorc").show();
            return false
          }
        }',
        'update'=>'#modalmensajec',
        'complete'=>'function(){
          $("#btn_cambiar").hide();
          $("#cuerpomodalc").hide();
          $("#modalmensajec").show();
        }',
      ),
        array(
          'id'=>'btn_cambiar',
          'class' => 'btn btn-primary',
        )
      );
      ?>
      <?php
      echo CHtml::ajaxLink(
        "Cerrar",
        array('reservacion/pagoscupon'),
        array(
         'type' => 'POST',
         'data'=>array('idCupon'=>$model->id_reservacion),
         'update'=>'#pagoscupon',
       ),
        array(
         'id'=>'btn_close',
         'class' => 'btn btn-default',
         'data-dismiss' => 'modal'
       )
      );
      ?>
    </div>
  </div>
</div>
</div>


<!-- modal cambio de moneda -->
<div id="modal_cambio_moneda" class="modal fade" aria-hidden="true">
    <form action="<?= Yii::app()->createUrl('reservacion/cambioMoneda'); ?>" method="POST">
      <div class="modal-dialog">
          <div class="modal-content">
              <div class="modal-header">
                  <h4>Cambiar moneda</h4>
              </div>
              <div class="modal-body">
                <p>
            <label>Valor dolar</label>
                  <input type="text" name="valor_dolar" class="form-control" required="required" value="<?= $model->tipo_cambio; ?>" />
                  <input type="hidden" name="id_reservacion" required="required" value="<?= $model->id_reservacion; ?>" />
                </p>
              </div>
              <div class="modal-footer">
                  <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
          <button type="submit" class="btn btn-primary" >Enviar</button>
              </div>
          </div>
      </div>
    </form>
</div>


<!-- modal pagar -->
<div id="modalpagar" class="modal modal-flex fade in" aria-labelledby="flexModalLabel" aria-hidden="true" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h4>Pagar Cupón <label id="lbl_cupon"></label>
                  <label class="pull-right" id="saldo"></label>
                  <label class="pull-right" id="saldo_sin_comision" style="display:none">
                      $<?=number_format(empty($model->tipo_cambio) ? $model->total:round($model->total_tc * $model->tipo_cambio,2),2)?>
                    </label>
                </h4>
            </div>
            <?php if(!empty($model->tipo_cambio)): ?>
            <div class="modal-body b-b">
              <form class="form-horizontal">
              <div class="form-group">
                  <label class="control-label col-sm-3">Tipo de Cambio</label>
                    <div class="col-sm-9">
                      <div class="input-group">
                        <input type="text" class="form-control text-right" id="tipo_cambio_field" value="<?=$model->tipo_cambio?>" />
                            <span class="input-group-btn">
                              <?php
                echo CHtml::ajaxLink(
                "Modificar",
                array('reservacion/modificartipocambio'),
                 array(
                 'type' => 'POST',
                 'dataType' => 'JSON',
                 'data'=>array('idCupon'=>$model->id_reservacion,'tipo_cambio'=>'js:$("#tipo_cambio_field").val()'),
                 'success'=>'function(data){
                   limpiamodal();
                   $("#saldo").html("$"+formato_numero(data.saldo,2,".",",")).show();
                   $("#saldo_sin_comision").html("$"+formato_numero(data.totalcambio,2,".",",")).hide();
                   $("#saldo_h").val(data.saldo);
                   $("#totalimporte").val(data.saldo);
                   $("#totalimporte_sc").val(data.totalcambio);
                   $(".comision-agencia").prop("checked",false);
                   $(".comision-agencia:first").prop("checked",true);
                 }',
                ),
                 array(
                  'id' => 'tipo_cambio_modify',
                                'class' => 'btn btn-success',
                            )
                );      
              ?>
                            </span>
                        </div>
                    </div>
                </div>
                </form>
            </div>
            <?php endif; ?>
            <div id="cuerpomodal" class="modal-body">
                <?php echo $this->renderPartial('formpagar', array('modelRecibo'=>$modelRecibo)); ?>
            </div>
            <div id="modalmensaje" class="modal-body"></div>
            <div id="modalupload" class="modal-body">
              <!-- $("#modalupload").show(); -->
              <div class="portlet portlet-default dropzone-portlet">
                    <div class="portlet-heading">
                        <div class="portlet-title">
                            <h4>Subir Comprobante de Pago</h4>
                        </div>
                        <div class="clearfix"></div>
                    </div>
                    <div class="portlet-body">
                        <form action="<?php echo Yii::app()->createUrl('pagos/subirarchivo'); ?>" class="dropzone" id="my-awesome-dropzone"><input type="hidden" name="idrecibo" id="idrecibo" /></form>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <?php
                echo CHtml::ajaxLink(
                "Pagar",
                array('pagos/pagarcuenta'),
                 array(
                 'type' => 'POST',
                 'data'=>'js:$("#recibo-form").serialize()',
                 'beforeSend'=>'function(){
                          if(($("#Recibo_id_tipo").val() == 8 || $("#Recibo_id_tipo").val() == 9) && ( $("#Recibo_tarjeta").val() == "" || $("#Recibo_id_banco").val() == "" || $("#Recibo_id_cuenta").val() == "" || $("#Recibo_id_planpago").val() == "" ) )
                          {
                            $("#pago_error").html("Error de Validación de tarjeta, faltan datos!");
                            $("#msg_error").show();
                            return false
                          }
                          else if($("#Recibo_id_tipo").val() == "" || $("#Recibo_importe").val() == "" || $("#Recibo_importe").val() == 0)
                          {
                            $("#pago_error").html("Error de Validación, ingrese tipo de pago o importe!");
                            $("#msg_error").show();
                            return false
                          }
                          /*if($(".comision-agencia:checked").val() == 1 && parseFloat($("#saldores").val()) != 0)
                          {
                            $("#pago_error").html("Error de Validación, debe pagar el importe exacto unicamente cuando se paga con comisión de la agencia!");
                            $("#msg_error").show();
                            return false
                          }*/
                        }',
                 'update'=>'#modalmensaje',
                 'complete'=>'function(){
                        $("#btn_pagar").hide();
                        $("#cuerpomodal").hide();
                        $("#modalmensaje").show();
                        $("#modalupload").show();
                        $("#idrecibo").val($("#id_recibo").val());
                        }',
                ),
                 array(
                  'id'=>'btn_pagar',
                                'class' => 'btn btn-primary',
                            )
                );
              ?>
                            <?php
                echo CHtml::ajaxLink(
                "Cerrar",
                array('reservacion/pagoscupon'),
                 array(
                 'type' => 'POST',
                 'data'=>array('idCupon'=>$model->id_reservacion),
                 'update'=>'#pagoscupon',
                ),
                 array(
                     'id'=>'btn_cerrar',
                                'class' => 'btn btn-default',
                  'data-dismiss' => 'modal'
                            )
                );
              ?>
            </div>
        </div>
    </div>
</div>